import org.junit.jupiter.api.Assertions;
import org.junit.jupiter.api.Test;

public class ViereckIstOKTest{
  @Test
  public void testnichtOK1() {
    ViereckInterface v = new Viereck(new Punkt(1,1), new Punkt(2,2)
        , new Punkt(3,2), new Punkt(4,2));
    Assertions.assertFalse(v.istOK());
  }
  
  @Test
  public void testnichtOK2() {
    ViereckInterface v = new Viereck(new Punkt(2,2), new Punkt(2,4)
        , new Punkt(3,2), new Punkt(2,5));
    Assertions.assertFalse(v.istOK());
  }
  
  @Test
  public void testnichtOK3() {
    ViereckInterface v = new Viereck(new Punkt(1,1), new Punkt(2,2)
        , new Punkt(3,2), null);
    Assertions.assertFalse(v.istOK());
  }
  
  @Test
  public void testnichtOK4() {
    ViereckInterface v = new Viereck(null, null, null, null);
    Assertions.assertFalse(v.istOK());
  }
  
  @Test
  public void testnichtOK5() {
    ViereckInterface v = new Viereck(new Punkt(1,1), new Punkt(2,2)
        , new Punkt(3,2), new Punkt(1,1));
    Assertions.assertFalse(v.istOK());
  }
  
  @Test
  public void testnichtOK6() {
    Punkt tmp = new Punkt(1,1);
    ViereckInterface v = new Viereck(tmp, new Punkt(2,2)
        , new Punkt(3,2),tmp);
    Assertions.assertFalse(v.istOK());
  }
  
  @Test
  public void testOK1() { // leider ok
    ViereckInterface v = new Viereck(new Punkt(1,1), new Punkt(2,2)
        , new Punkt(3,3), new Punkt(4,2));
    Assertions.assertTrue(v.istOK());
  }
  
  @Test
  public void testOK2() { // leider ok
    ViereckInterface v = new Viereck(new Punkt(1,1), new Punkt(1,5)
        , new Punkt(5,1), new Punkt(5,5));
    Assertions.assertTrue(v.istOK());
  }
}
